﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SyntaxTree
{
    public abstract class Visitor
    {
        public virtual void visit(SyntaxTreeNode _SyntaxTreeNode)
        {}
        public virtual void visit(Statement _SyntaxTree)
        { }
        public virtual void visit(AssignStatement _AssignStatement)
        { }
        public virtual void visit(WhileStatement _WhileStatement)
        { }
        public virtual void visit(EmptyStatement _EmptyStatement)
        { }
        public virtual void visit(MainBlock _MainBlock)
        { }
        public virtual void visit(VarList _VarList)
        { }
        public virtual void visit(StatementList _StatementList)
        { }
        public virtual void visit(VarWithIndexList _VarWithIndexList)
        { }
     
        public virtual void visit(IfStatement _IfStatemente)
        { }
        public virtual void visit(Expression _BlockStatement)
        { }
        public virtual void visit(BinaryExpression _BinaryNode)
        { }
        public virtual void visit(UnaryExpression _UnaryNode)
        { }
        public virtual void visit(VarNode _VarNode)
        { }
        public virtual void visit(ConstExpression _ConstNode)
        { }
        public virtual void visit(BoolConstExpression _BoolConstNode)
        { }
        public virtual void visit(IntConstExpression _IntConstNode)
        { }
        public virtual void visit(DoubleConstExpression _DoubleConstNode)
        { }
       
        public virtual void visit(VarWithIndex _VarWithIndex)
        { }
        public virtual void visit(VarDefStatement _VarDefStatement)
        { }
        public virtual void visit(VarWithIndexDefStatement _VarWithIndexDefStatement)
        { }
    }
}
